/*
 *+--------------------------------------------------------------------------------------+
 *| Licensed Materials - Use restricted, please refer to the "Samples Gallery" terms and |
 *| conditions in the IBM International Program License Agreement.						 |	
 *|  Copyright IBM Corporation 2003, 2004. All Rights Reserved.						 |
 *+--------------------------------------------------------------------------------------+
 */

package itso.ad.citybank;

public class CityBankProxy implements itso.ad.citybank.CityBank {
  private boolean _useJNDI = true;
  private String _endpoint = null;
  private itso.ad.citybank.CityBank cityBank = null;
  
  public CityBankProxy() {
    _initCityBankProxy();
  }
  
  private void _initCityBankProxy() {
  
  if (_useJNDI) {
    try{
      javax.naming.InitialContext ctx = new javax.naming.InitialContext();
      cityBank = ((itso.ad.citybank.CityBankService)ctx.lookup("java:comp/env/service/cityBankService")).getCityBank();
      }
    catch (javax.naming.NamingException namingException) {}
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  if (cityBank == null) {
    try{
      cityBank = (new itso.ad.citybank.CityBankServiceLocator()).getCityBank();
      }
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  if (cityBank != null) {
    if (_endpoint != null)
      ((javax.xml.rpc.Stub)cityBank)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
    else
      _endpoint = (String)((javax.xml.rpc.Stub)cityBank)._getProperty("javax.xml.rpc.service.endpoint.address");
  }
  
}


public void useJNDI(boolean useJNDI) {
  _useJNDI = useJNDI;
  cityBank = null;
  
}

public String getEndpoint() {
  return _endpoint;
}

public void setEndpoint(String endpoint) {
  _endpoint = endpoint;
  if (cityBank != null)
    ((javax.xml.rpc.Stub)cityBank)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
  
}

public itso.ad.citybank.CityBank getCityBank() {
  if (cityBank == null)
    _initCityBankProxy();
  return cityBank;
}

public boolean validateCheck(java.lang.String checkReference, int amount) throws java.rmi.RemoteException{
  if (cityBank == null)
    _initCityBankProxy();
  return cityBank.validateCheck(checkReference, amount);
}


}